local select = select
local ipairs = ipairs
local Talented = Talented

local L = LibStub("AceLocale-3.0"):GetLocale("Talented")

function Talented:UpdateClassName(unit)
	if not UnitIsPlayer(unit) then return end
	local name, class = UnitClass(unit)
	if not name then return end
	local _, level = self:GetClassName(class)
	if level == 3 then return end
	local entry = self.classNames[class]
	local sex = UnitSex(unit)
	if sex == 3 and level == 1 then
		entry[1] = name
		entry[2] = 2
		self:UpdateMenuClass(class, name)
	elseif sex == 2 then
		entry[1] = name
		entry[2] = 3
		self:UpdateMenuClass(class, name)
		for _, e in pairs(self.classNames) do
			if e[2] < 3 then return end
		end
		self:StopUnitCheck()
	end
end

function Talented:StartUnitCheck()
	local names = {}
	self.classNames = names
	local bc = LibStub("LibBabble-Class-3.0", true)
	if bc then
		bc = bc:GetLookupTable()
		for class in pairs(RAID_CLASS_COLORS) do
			local n = class:sub(1, 1):upper()..class:sub(2):lower()
			names[class] = { bc[n], 3 }
		end
		self.UpdateMenuClass = nil
		self.UpdateClassName = nil
	else
		for class in pairs(RAID_CLASS_COLORS) do
			local n = class:sub(1, 1):upper()..class:sub(2):lower()
			names[class] = { n, 1 }
		end
		self:UpdateClassName("player")
		function self:PLAYER_FOCUS_CHANGED()
			self:UpdateClassName("focus")
		end
		self:RegisterEvent"PLAYER_FOCUS_CHANGED"
		function self:PLAYER_TARGET_CHANGED()
			self:UpdateClassName("target")
		end
		self:RegisterEvent"PLAYER_TARGET_CHANGED"
		function self:UPDATE_MOUSEOVER_UNIT()
			self:UpdateClassName("mouseover")
		end
		self:RegisterEvent"UPDATE_MOUSEOVER_UNIT"
		function self:PARTY_MEMBERS_CHANGED()
			for i = 1, 4 do
				local unit = "party"..i
				if UnitExists(unit) then
					self:UpdateClassName(unit)
				end
			end
		end
		self:RegisterEvent"PARTY_MEMBERS_CHANGED"
		function self:RAID_ROSTER_UPDATE()
			for i = 1, 40 do
				local unit = "raid"..i
				if UnitExists(unit) then
					self:UpdateClassName(unit)
				end
			end
		end
		self:RegisterEvent"RAID_ROSTER_UPDATE"
		function self:StopUnitCheck()
			self:UnregisterEvent"PLAYER_FOCUS_CHANGED"
			self:UnregisterEvent"PLAYER_TARGET_CHANGED"
			self:UnregisterEvent"UPDATE_MOUSEOVER_UNIT"
			self:UnregisterEvent"PARTY_MEMBERS_CHANGED"
			self:UnregisterEvent"RAID_ROSTER_UPDATE"
			self.PLAYER_FOCUS_CHANGED = nil
			self.PLAYER_TARGET_CHANGED = nil
			self.UPDATE_MOUSEOVER_UNIT = nil
			self.PARTY_MEMBERS_CHANGED = nil
			self.RAID_ROSTER_UPDATE = nil
			self.StopUnitCheck = nil
			self.UpdateMenuClass = nil
			self.UpdateClassName = nil
		end
	end
	self.StartUnitCheck = nil
	return names
end

function Talented:GetClassName(class)
	local names = self.classNames
	if not names then
		names = self:StartUnitCheck()
	end
	if names[class] then
		return unpack(names[class])
	else
		return class
	end
end
